commit:     8612d878967806a5cca28ba9075daf9d2087023a
Author:     tt_1 <herrtimson <AT> yahoo <DOT> de>
AuthorDate: Sat May  2 23:48:01 2015 +0000
Commit:     Anthony G. Basile <blueness <AT> gentoo <DOT> org>
CommitDate: Sat May  2 23:48:01 2015 +0000
URL:        https://gitweb.gentoo.org/proj/hardened-dev.git/commit/?id=8612d878

app-office/libreoffice: see bug #546890.

 .../libreoffice-4.3.5.2-remove-bashisms.patch      |  38 ++
 .../files/libreoffice-4.4-system-pyuno.patch       |  44 ++
 ...breoffice-4.4.0.3-gcc-4.9-Os-link-failure.patch |  80 +++
 .../libreoffice-4.4.0.3-telepathy-build-fix.patch  |  40 ++
 ...reoffice-4.4.1.2-add-kde4-open-url-script.patch |  56 ++
 .../files/libreoffice-4.4.1.2-fix-includes.patch   |  31 ++
 ...ibreoffice-4.4.1.2-improve-KDE4FilePicker.patch | 192 +++++++
 .../files/libreoffice-4.4.1.2-linux-musl.patch     |  68 +++
 .../libreoffice-4.4.1.2-musl-fix-execinfo.patch    |  24 +
 .../libreoffice/libreoffice-4.4.1.2-r99.ebuild     | 619 +++++++++++++++++++++
 app-office/libreoffice/metadata.xml                |  20 +
 11 files changed, 1212 insertions(+)

diff --git 
a/app-office/libreoffice/files/libreoffice-4.3.5.2-remove-bashisms.patch 
b/app-office/libreoffice/files/libreoffice-4.3.5.2-remove-bashisms.patch
new file mode 100644
index 0000000..370b4aa
--- /dev/null
+++ b/app-office/libreoffice/files/libreoffice-4.3.5.2-remove-bashisms.patch
@@ -0,0 +1,38 @@
+From f53e79acd0d42f5c41e1104056af9cf23e9e2e2a Mon Sep 17 00:00:00 2001
+From: "Andreas K. Huettel (dilfridge)" <[email protected]>
+Date: Sun, 4 Jan 2015 15:33:35 +0100
+Subject: [PATCH] Replace bash-specific code from configure.ac, fixes build for
+ sh=dash users
+MIME-Version: 1.0
+Content-Type: text/plain; charset=UTF-8
+Content-Transfer-Encoding: 8bit
+
+Original patch by Rémi Cardona <[email protected]>
+
+Change-Id: I815567df8a868c3997e8ac357b8529fded28c950
+Gentoo-Bug: https://bugs.gentoo.org/show_bug.cgi?id=525454
+Reviewed-on: https://gerrit.libreoffice.org/13731
+Reviewed-by: Caolán McNamara <[email protected]>
+Tested-by: Caolán McNamara <[email protected]>
+---
+ configure.ac | 3 +--
+ 1 file changed, 1 insertion(+), 2 deletions(-)
+
+diff --git a/configure.ac b/configure.ac
+index 8aa33d0..5dbe640 100644
+--- a/configure.ac
++++ b/configure.ac
+@@ -11483,9 +11483,8 @@ test_font_map()
+     FONTFILE_LOWER="$(echo $FONTFILE | $AWK '{print tolower($0)}')"
+ 
+     TESTEXPR="'${FONTFILE_LOWER}' = '$(echo $FONT | $AWK '{print 
tolower($0)}').ttf'"
+-    while true ; do
++    while test "$#" -ge 1 ; do
+         MAPPING="$(echo $1 | $AWK '{print tolower($0)}')"; shift
+-        test -n "$MAPPING" || break
+         TESTEXPR="${TESTEXPR} -o '${FONTFILE_LOWER}' = '$MAPPING-regular.ttf'"
+     done
+     if test $TESTEXPR
+-- 
+2.3.0
+

diff --git a/app-office/libreoffice/files/libreoffice-4.4-system-pyuno.patch 
b/app-office/libreoffice/files/libreoffice-4.4-system-pyuno.patch
new file mode 100644
index 0000000..1cf8e19
--- /dev/null
+++ b/app-office/libreoffice/files/libreoffice-4.4-system-pyuno.patch
@@ -0,0 +1,44 @@
+diff --git a/desktop/scripts/soffice.sh b/desktop/scripts/soffice.sh
+index a259bf6..672fa23 100755
+--- a/desktop/scripts/soffice.sh
++++ b/desktop/scripts/soffice.sh
+@@ -129,6 +129,9 @@ if echo "$checks" | grep -q "cc" ; then
+     exit 1;
+ fi
+ 
++PYTHONPATH=$sd_prog${PYTHONPATH+:$PYTHONPATH}
++export PYTHONPATH
++
+ case "`uname -s`" in
+ NetBSD|OpenBSD|FreeBSD|DragonFly)
+ # this is a temporary hack until we can live with the default search paths
+diff --git a/pyuno/source/module/uno.py b/pyuno/source/module/uno.py
+index 4ff2606..6a05eed 100644
+--- a/pyuno/source/module/uno.py
++++ b/pyuno/source/module/uno.py
+@@ -16,8 +16,12 @@
+ #   except in compliance with the License. You may obtain a copy of
+ #   the License at http://www.apache.org/licenses/LICENSE-2.0 .
+ #
++import os
+ import sys
+ 
++sys.path.append('%eprefix%/usr/%libdir%/libreoffice/program')
++if getattr(os.environ, 'URE_BOOTSTRAP', None) is None:
++    os.environ['URE_BOOTSTRAP'] = 
"vnd.sun.star.pathname:%eprefix%/usr/%libdir%/libreoffice/program/fundamentalrc"
+ import pyuno
+ 
+ try:
+diff --git a/pyuno/source/officehelper.py b/pyuno/source/officehelper.py
+index 99d3b03..704edab 100755
+--- a/pyuno/source/officehelper.py
++++ b/pyuno/source/officehelper.py
+@@ -44,7 +44,7 @@ def bootstrap():
+         if "UNO_PATH" in os.environ:
+             sOffice = os.environ["UNO_PATH"]
+         else:
+-            sOffice = "" # lets hope for the best
++            sOffice = "%eprefix%/usr/%libdir%/libreoffice/program"
+         sOffice = os.path.join(sOffice, "soffice")
+         if platform.startswith("win"): 
+             sOffice += ".exe"

diff --git 
a/app-office/libreoffice/files/libreoffice-4.4.0.3-gcc-4.9-Os-link-failure.patch
 
b/app-office/libreoffice/files/libreoffice-4.4.0.3-gcc-4.9-Os-link-failure.patch
new file mode 100644
index 0000000..0f39688
--- /dev/null
+++ 
b/app-office/libreoffice/files/libreoffice-4.4.0.3-gcc-4.9-Os-link-failure.patch
@@ -0,0 +1,80 @@
+From 0e4b1d2127957459b79f41a96f1fa0061d399b3b Mon Sep 17 00:00:00 2001
+From: Michael Stahl <[email protected]>
+Date: Sat, 14 Feb 2015 00:17:06 +0100
+Subject: tdf#78174: toolkit: work around GCC 4.9 -Os link failure
+
+A build with gcc (GCC) 4.9.2 20141101 (Red Hat 4.9.2-1) for 32-bit x86
+fails because of these undefined symbols:
+
+> nm --demangle workdir/CxxObject/svx/source/fmcomp/fmgridif.o | grep
+ \\bWindowListenerMultiplexer::acquire
+         U non-virtual thunk to WindowListenerMultiplexer::acquire()
+
+They should probably be generated inline.  Work around by out-lining the
+definition of the methods.
+
+https://gcc.gnu.org/bugzilla/show_bug.cgi?id=64812
+
+Change-Id: I318f7c39bdf1243be385bc6dc0a47862b22e92c5
+(cherry picked from commit 6b3aa0fe4094e87290bd33a30bd6cd99ee78ce38)
+Reviewed-on: https://gerrit.libreoffice.org/14509
+Reviewed-by: Miklos Vajna <[email protected]>
+Tested-by: Miklos Vajna <[email protected]>
+
+diff --git a/include/toolkit/helper/macros.hxx 
b/include/toolkit/helper/macros.hxx
+index e048e75..b212dff 100644
+--- a/include/toolkit/helper/macros.hxx
++++ b/include/toolkit/helper/macros.hxx
+@@ -112,8 +112,8 @@ class ClassName : public ListenerMultiplexerBase, public 
InterfaceName \
+ public: \
+     ClassName( ::cppu::OWeakObject& rSource ); \
+     ::com::sun::star::uno::Any  SAL_CALL queryInterface( const 
::com::sun::star::uno::Type & rType ) 
throw(::com::sun::star::uno::RuntimeException, std::exception) SAL_OVERRIDE; \
+-    void                        SAL_CALL acquire() throw() SAL_OVERRIDE  { 
ListenerMultiplexerBase::acquire(); } \
+-    void                        SAL_CALL release() throw() SAL_OVERRIDE  { 
ListenerMultiplexerBase::release(); } \
++    void                        SAL_CALL acquire() throw() SAL_OVERRIDE; \
++    void                        SAL_CALL release() throw() SAL_OVERRIDE; \
+     void                        SAL_CALL disposing( const 
::com::sun::star::lang::EventObject& Source ) 
throw(::com::sun::star::uno::RuntimeException, std::exception) SAL_OVERRIDE;
+ 
+ 
+@@ -124,8 +124,8 @@ class TOOLKIT_DLLPUBLIC ClassName : public 
ListenerMultiplexerBase, public Inter
+ public: \
+     ClassName( ::cppu::OWeakObject& rSource ); \
+     ::com::sun::star::uno::Any  SAL_CALL queryInterface( const 
::com::sun::star::uno::Type & rType ) 
throw(::com::sun::star::uno::RuntimeException, std::exception) SAL_OVERRIDE; \
+-    void                        SAL_CALL acquire() throw() SAL_OVERRIDE  { 
ListenerMultiplexerBase::acquire(); } \
+-    void                        SAL_CALL release() throw() SAL_OVERRIDE  { 
ListenerMultiplexerBase::release(); } \
++    void                        SAL_CALL acquire() throw() SAL_OVERRIDE; \
++    void                        SAL_CALL release() throw() SAL_OVERRIDE; \
+     void                        SAL_CALL disposing( const 
::com::sun::star::lang::EventObject& Source ) 
throw(::com::sun::star::uno::RuntimeException, std::exception) SAL_OVERRIDE;
+ 
+ 
+@@ -140,6 +140,8 @@ ClassName::ClassName( ::cppu::OWeakObject& rSource ) \
+     : ListenerMultiplexerBase( rSource ) \
+ { \
+ } \
++void SAL_CALL ClassName::acquire() throw() { 
ListenerMultiplexerBase::acquire(); } \
++void SAL_CALL ClassName::release() throw() { 
ListenerMultiplexerBase::release(); } \
+ ::com::sun::star::uno::Any ClassName::queryInterface( const 
::com::sun::star::uno::Type & rType ) 
throw(::com::sun::star::uno::RuntimeException, std::exception) \
+ { \
+     ::com::sun::star::uno::Any aRet = ::cppu::queryInterface( rType, \
+diff --git a/toolkit/source/helper/listenermultiplexer.cxx 
b/toolkit/source/helper/listenermultiplexer.cxx
+index 797fad2..b109c5f 100644
+--- a/toolkit/source/helper/listenermultiplexer.cxx
++++ b/toolkit/source/helper/listenermultiplexer.cxx
+@@ -47,6 +47,15 @@ EventListenerMultiplexer::EventListenerMultiplexer( 
::cppu::OWeakObject& rSource
+ {
+ }
+ 
++void SAL_CALL EventListenerMultiplexer::acquire() throw ()
++{
++    return ListenerMultiplexerBase::acquire();
++}
++void SAL_CALL EventListenerMultiplexer::release() throw ()
++{
++    return ListenerMultiplexerBase::release();
++}
++
+ // ::com::sun::star::uno::XInterface
+ ::com::sun::star::uno::Any EventListenerMultiplexer::queryInterface( const 
::com::sun::star::uno::Type & rType ) 
throw(::com::sun::star::uno::RuntimeException, std::exception)
+ {
+-- 
+cgit v0.10.2

diff --git 
a/app-office/libreoffice/files/libreoffice-4.4.0.3-telepathy-build-fix.patch 
b/app-office/libreoffice/files/libreoffice-4.4.0.3-telepathy-build-fix.patch
new file mode 100644
index 0000000..2833385
--- /dev/null
+++ b/app-office/libreoffice/files/libreoffice-4.4.0.3-telepathy-build-fix.patch
@@ -0,0 +1,40 @@
+From 623b38fa5769f8cdec10b54b2a600bc4c4e077e6 Mon Sep 17 00:00:00 2001
+From: David Tardon <[email protected]>
+Date: Sun, 11 Jan 2015 13:08:37 +0100
+Subject: OSL_ENSURE was not declared in this scope
+
+Change-Id: I426c0feee7b76fe02473e07fa209a61967af3e99
+
+diff --git a/tubes/source/conference.cxx b/tubes/source/conference.cxx
+index 86986fc..df4a63f 100644
+--- a/tubes/source/conference.cxx
++++ b/tubes/source/conference.cxx
+@@ -248,7 +248,7 @@ static void channel_closed_cb( TpChannel *channel, 
gpointer user_data, GObject *
+ 
+ void TeleConference::setChannel( TpAccount *pAccount, TpDBusTubeChannel* 
pChannel )
+ {
+-    OSL_ENSURE( !mpChannel, "TeleConference::setChannel: already have 
channel");
++    SAL_WARN_IF( mpChannel, "tubes", "TeleConference::setChannel: already 
have channel");
+     if (mpChannel)
+         g_object_unref( mpChannel);
+     if (mpAccount)
+@@ -297,7 +297,7 @@ bool TeleConference::offerTube()
+ {
+     INFO_LOGGER( "TeleConference::offerTube");
+ 
+-    OSL_ENSURE( mpChannel, "TeleConference::offerTube: no channel");
++    SAL_WARN_IF( !mpChannel, "tubes", "TeleConference::offerTube: no 
channel");
+     if (!mpChannel)
+         return false;
+ 
+@@ -319,7 +319,7 @@ bool TeleConference::setTube( GDBusConnection* pTube)
+ {
+     INFO_LOGGER( "TeleConference::setTube");
+ 
+-    OSL_ENSURE( !pImpl->mpTube, "TeleConference::setTube: already tubed");
++    SAL_WARN_IF( pImpl->mpTube, "tubes", "TeleConference::setTube: already 
tubed");
+ 
+     pImpl->mpTube = pTube;
+ 
+-- 
+cgit v0.10.2

diff --git 
a/app-office/libreoffice/files/libreoffice-4.4.1.2-add-kde4-open-url-script.patch
 
b/app-office/libreoffice/files/libreoffice-4.4.1.2-add-kde4-open-url-script.patch
new file mode 100644
index 0000000..d4c4d28
--- /dev/null
+++ 
b/app-office/libreoffice/files/libreoffice-4.4.1.2-add-kde4-open-url-script.patch
@@ -0,0 +1,56 @@
+From f7db2461292be3e23f5b3af47e488eaa8105d8db Mon Sep 17 00:00:00 2001
+From: Jan-Marek Glogowski <[email protected]>
+Date: Wed, 26 Nov 2014 13:35:42 +0100
+Subject: Add kde4-open-url script
+
+Adds a KDE4 specific URL processing script.
+
+Change-Id: I0116fa95f076a5772e88c616e93de542fe4fe4e4
+
+diff --git a/shell/Package_scripts_kde.mk b/shell/Package_scripts_kde.mk
+index c5e4978..162bcc5 100644
+--- a/shell/Package_scripts_kde.mk
++++ b/shell/Package_scripts_kde.mk
+@@ -9,6 +9,12 @@
+ 
+ $(eval $(call 
gb_Package_Package,shell_scripts_kde,$(SRCDIR)/shell/source/unix/misc))
+ 
++ifeq ($(ENABLE_KDE),TRUE)
+ $(eval $(call 
gb_Package_add_file,shell_scripts_kde,$(LIBO_BIN_FOLDER)/kde-open-url,kde-open-url.sh))
++endif
++
++ifeq ($(ENABLE_KDE4),TRUE)
++$(eval $(call 
gb_Package_add_file,shell_scripts_kde,$(LIBO_BIN_FOLDER)/kde4-open-url,kde4-open-url.sh))
++endif
+ 
+ # vim: set shiftwidth=4 tabstop=4 noexpandtab:
+diff --git a/shell/source/unix/misc/kde4-open-url.sh 
b/shell/source/unix/misc/kde4-open-url.sh
+new file mode 100755
+index 0000000..e5b8125
+--- /dev/null
++++ b/shell/source/unix/misc/kde4-open-url.sh
+@@ -0,0 +1,22 @@
++#!/bin/sh
++#
++# This file is part of the LibreOffice project.
++#
++# This Source Code Form is subject to the terms of the Mozilla Public
++# License, v. 2.0. If a copy of the MPL was not distributed with this
++# file, You can obtain one at http://mozilla.org/MPL/2.0/.
++#
++# This file incorporates work covered by the following license notice:
++#
++#   Licensed to the Apache Software Foundation (ASF) under one or more
++#   contributor license agreements. See the NOTICE file distributed
++#   with this work for additional information regarding copyright
++#   ownership. The ASF licenses this file to you under the Apache
++#   License, Version 2.0 (the "License"); you may not use this file
++#   except in compliance with the License. You may obtain a copy of
++#   the License at http://www.apache.org/licenses/LICENSE-2.0 .
++#
++
++# use kde-open or xdg-open if available, falling back to our own open-url
++kde-open "$1" 2>/dev/null || xdg-open "$1" 2>/dev/null || `dirname 
"$0"`/open-url "$1" 2>/dev/null
++exit 0
+-- 
+cgit v0.10.2

diff --git 
a/app-office/libreoffice/files/libreoffice-4.4.1.2-fix-includes.patch 
b/app-office/libreoffice/files/libreoffice-4.4.1.2-fix-includes.patch
new file mode 100644
index 0000000..b1f1b44
--- /dev/null
+++ b/app-office/libreoffice/files/libreoffice-4.4.1.2-fix-includes.patch
@@ -0,0 +1,31 @@
+--- libreoffice-4.4.0.3/vcl/inc/headless/svpinst.hxx   2015-02-02 
20:38:46.879497689 -0200
++++ libreoffice-4.4.0.3/vcl/inc/headless/svpinst.hxx   2015-02-02 
20:38:55.482831474 -0200
+@@ -32,6 +32,7 @@
+ #include <list>
+ 
+ #include <time.h>
++#include <sys/time.h>
+ 
+ #define VIRTUAL_DESKTOP_WIDTH 1024
+ #define VIRTUAL_DESKTOP_HEIGHT 768
+--- libreoffice-4.4.0.3/vcl/unx/generic/gdi/cairotextrender.cxx        
2015-02-02 21:19:22.822959064 -0200
++++ libreoffice-4.4.0.3/vcl/unx/generic/gdi/cairotextrender.cxx        
2015-02-02 21:19:48.312960404 -0200
+@@ -18,6 +18,7 @@
+  */
+ 
+ #include "cairotextrender.hxx"
++#include "generic/glyphcache.hxx"
+ 
+ #include <basegfx/polygon/b2dpolypolygon.hxx>
+ #include <vcl/settings.hxx>
+--- libreoffice-4.4.0.3/sd/source/ui/remotecontrol/BluetoothServer.cxx 
2015-02-03 08:42:36.590056362 -0200
++++ libreoffice-4.4.0.3/sd/source/ui/remotecontrol/BluetoothServer.cxx 
2015-02-03 08:42:46.030056456 -0200
+@@ -22,7 +22,7 @@
+   #include <dbus/dbus.h>
+   #include <errno.h>
+   #include <fcntl.h>
+-  #include <sys/unistd.h>
++  #include <unistd.h>
+   #include <sys/socket.h>
+   #include <bluetooth/bluetooth.h>
+   #include <bluetooth/rfcomm.h>

diff --git 
a/app-office/libreoffice/files/libreoffice-4.4.1.2-improve-KDE4FilePicker.patch 
b/app-office/libreoffice/files/libreoffice-4.4.1.2-improve-KDE4FilePicker.patch
new file mode 100644
index 0000000..61e036e
--- /dev/null
+++ 
b/app-office/libreoffice/files/libreoffice-4.4.1.2-improve-KDE4FilePicker.patch
@@ -0,0 +1,192 @@
+Merged upstream commits:
+
+6fc55b9abd783b624241d56e34751ea495adbd7d       "KDE4: actually apply file 
dialog operation mode"
+b613270a730ace29dd1b16b29be2222b34f34a5d       "KDE4: improve default load and 
save dialog titles"
+
+
+diff -u b/vcl/unx/kde4/KDE4FilePicker.cxx b/vcl/unx/kde4/KDE4FilePicker.cxx
+--- b/vcl/unx/kde4/KDE4FilePicker.cxx
++++ b/vcl/unx/kde4/KDE4FilePicker.cxx
+@@ -58,6 +58,8 @@
+ 
+ #include "generic/geninst.h"
+ 
++#include "svids.hrc"
++
+ using namespace ::com::sun::star;
+ using namespace ::com::sun::star::ui::dialogs;
+ using namespace ::com::sun::star::ui::dialogs::TemplateDescription;
+@@ -109,7 +111,6 @@
+ 
+ KDE4FilePicker::KDE4FilePicker( const uno::Reference<uno::XComponentContext>& 
)
+     : KDE4FilePicker_Base(_helperMutex)
+-    , _resMgr( ResMgr::CreateResMgr("fps_office") )
+     , allowRemoteUrls( false )
+ {
+     _extraControls = new QWidget();
+@@ -128,8 +129,7 @@
+ #endif
+ 
+     setMultiSelectionMode( false );
+-    //default mode
+-    _dialog->setOperationMode(KFileDialog::Opening);
++    _dialog->setConfirmOverwrite( true );
+ 
+     // XExecutableDialog functions
+     connect( this, SIGNAL( setTitleSignal( const OUString & ) ),
+@@ -202,7 +202,6 @@
+         SalYieldMutexReleaser aReleaser;
+         return Q_EMIT cleanupProxySignal();
+     }
+-    delete _resMgr;
+     delete _dialog;
+ }
+ 
+@@ -524,6 +523,24 @@
+     return toOUString(label);
+ }
+ 
++QString KDE4FilePicker::getResString( sal_Int16 aRedId )
++{
++    QString aResString;
++
++    if( aRedId < 0 )
++        return aResString;
++
++    try
++    {
++        aResString = toQString(ResId(aRedId, *ImplGetResMgr()).toString());
++    }
++    catch(...)
++    {
++    }
++
++    return aResString.replace('~', '&');
++}
++
+ void KDE4FilePicker::addCustomControl(sal_Int16 controlId)
+ {
+     QWidget* widget = 0;
+@@ -532,37 +549,37 @@
+     switch (controlId)
+     {
+         case CHECKBOX_AUTOEXTENSION:
+-            resId = STR_SVT_FILEPICKER_AUTO_EXTENSION;
++            resId = STR_FPICKER_AUTO_EXTENSION;
+             break;
+         case CHECKBOX_PASSWORD:
+-            resId = STR_SVT_FILEPICKER_PASSWORD;
++            resId = STR_FPICKER_PASSWORD;
+             break;
+         case CHECKBOX_FILTEROPTIONS:
+-            resId = STR_SVT_FILEPICKER_FILTER_OPTIONS;
++            resId = STR_FPICKER_FILTER_OPTIONS;
+             break;
+         case CHECKBOX_READONLY:
+-            resId = STR_SVT_FILEPICKER_READONLY;
++            resId = STR_FPICKER_READONLY;
+             break;
+         case CHECKBOX_LINK:
+-            resId = STR_SVT_FILEPICKER_INSERT_AS_LINK;
++            resId = STR_FPICKER_INSERT_AS_LINK;
+             break;
+         case CHECKBOX_PREVIEW:
+-            resId = STR_SVT_FILEPICKER_SHOW_PREVIEW;
++            resId = STR_FPICKER_SHOW_PREVIEW;
+             break;
+         case CHECKBOX_SELECTION:
+-            resId = STR_SVT_FILEPICKER_SELECTION;
++            resId = STR_FPICKER_SELECTION;
+             break;
+         case PUSHBUTTON_PLAY:
+-            resId = STR_SVT_FILEPICKER_PLAY;
++            resId = STR_FPICKER_PLAY;
+             break;
+         case LISTBOX_VERSION:
+-            resId = STR_SVT_FILEPICKER_VERSION;
++            resId = STR_FPICKER_VERSION;
+             break;
+         case LISTBOX_TEMPLATE:
+-            resId = STR_SVT_FILEPICKER_TEMPLATES;
++            resId = STR_FPICKER_TEMPLATES;
+             break;
+         case LISTBOX_IMAGE_TEMPLATE:
+-            resId = STR_SVT_FILEPICKER_IMAGE_TEMPLATE;
++            resId = STR_FPICKER_IMAGE_TEMPLATE;
+             break;
+         case LISTBOX_VERSION_LABEL:
+         case LISTBOX_TEMPLATE_LABEL:
+@@ -581,16 +598,7 @@
+         case CHECKBOX_PREVIEW:
+         case CHECKBOX_SELECTION:
+         {
+-            QString label;
+-
+-            if (_resMgr && resId != -1)
+-            {
+-                OUString s(ResId(resId, *_resMgr).toString());
+-                label = toQString(s);
+-                label.replace("~", "&");
+-            }
+-
+-            widget = new QCheckBox(label, _extraControls);
++            widget = new QCheckBox(getResString(resId), _extraControls);
+ 
+             // the checkbox is created even for CHECKBOX_AUTOEXTENSION to 
simplify
+             // code, but the checkbox is hidden and ignored
+@@ -719,8 +727,22 @@
+                     1 );
+     }
+ 
+-    _dialog->setOperationMode(operationMode);
+-    _dialog->setConfirmOverwrite(true);
++    _dialog->setOperationMode( operationMode );
++
++    sal_Int16 resId = -1;
++    switch (_dialog->operationMode())
++    {
++    case KFileDialog::Opening:
++        resId = STR_FPICKER_OPEN;
++        break;
++    case KFileDialog::Saving:
++        resId = STR_FPICKER_SAVE;
++        break;
++    default:
++        break;
++    }
++
++    _dialog->setCaption(getResString(resId));
+ }
+ 
+ void SAL_CALL KDE4FilePicker::cancel()
+only in patch2:
+unchanged:
+--- a/vcl/unx/kde4/KDE4FilePicker.hxx
++++ b/vcl/unx/kde4/KDE4FilePicker.hxx
+@@ -41,8 +41,6 @@ class KFileDialog;
+ class QWidget;
+ class QLayout;
+ 
+-class ResMgr;
+-
+ typedef ::cppu::WeakComponentImplHelper5
+ <   ::com::sun::star::ui::dialogs::XFilePicker2
+ ,   ::com::sun::star::ui::dialogs::XFilePicker3
+@@ -61,8 +59,6 @@ protected:
+ 
+     ::com::sun::star::uno::Reference< 
::com::sun::star::ui::dialogs::XFilePickerListener > m_xListener;
+ 
+-    ResMgr *_resMgr;
+-
+     //the dialog to display
+     KFileDialog* _dialog;
+ 
+@@ -225,6 +221,8 @@ private:
+     //add a custom control widget to the file dialog
+     void addCustomControl(sal_Int16 controlId);
+ 
++    QString getResString( sal_Int16 aRedId );
++
+ private Q_SLOTS:
+     void cleanupProxy();
+     void checkProtocol();

diff --git a/app-office/libreoffice/files/libreoffice-4.4.1.2-linux-musl.patch 
b/app-office/libreoffice/files/libreoffice-4.4.1.2-linux-musl.patch
new file mode 100644
index 0000000..5c8ab52
--- /dev/null
+++ b/app-office/libreoffice/files/libreoffice-4.4.1.2-linux-musl.patch
@@ -0,0 +1,68 @@
+--- libreoffice-4.4.0.3/configure.ac.orig      2015-01-22 22:05:28.000000000 
-0200
++++ libreoffice-4.4.0.3/configure.ac   2015-02-02 20:11:20.639411153 -0200
+@@ -569,7 +569,7 @@
+     fi
+     ;;
+ 
+-linux-gnu*|k*bsd*-gnu*)
++linux-gnu*|linux-musl*|k*bsd*-gnu*)
+     test_gtk=yes
+     build_gstreamer_1_0=yes
+     build_gstreamer_0_10=yes
+@@ -4058,7 +4058,7 @@
+     esac
+     ;;
+ 
+-linux-gnu*)
++linux-gnu*|linux-musl*)
+     COM=GCC
+     GUIBASE=unx
+     OS=LINUX
+@@ -6967,7 +6967,7 @@
+         test -d "$JAVA_HOME/include/native_thread" && JAVAINC="$JAVAINC 
-I$JAVA_HOME/include/native_thread"
+         ;;
+ 
+-    linux-gnu*)
++    linux-gnu*|linux-musl*)
+         JAVAINC="-I$JAVA_HOME/include"
+         JAVAINC="$JAVAINC -I$JAVA_HOME/include/linux"
+         test -d "$JAVA_HOME/include/native_thread" && JAVAINC="$JAVAINC 
-I$JAVA_HOME/include/native_thread"
+@@ -9429,21 +9429,6 @@
+ fi
+ AC_SUBST(SYSTEM_LIBEXTTEXTCAT_DATA)
+ 
+-dnl ***************************************
+-dnl testing libc version for Linux...
+-dnl ***************************************
+-if test "$_os" = "Linux"; then
+-    AC_MSG_CHECKING([whether libc is >= 2.1.1])
+-    exec 6>/dev/null # no output
+-    AC_CHECK_LIB(c, gnu_get_libc_version, HAVE_LIBC=yes; export HAVE_LIBC)
+-    exec 6>&1 # output on again
+-    if test "$HAVE_LIBC"; then
+-        AC_MSG_RESULT([yes])
+-    else
+-        AC_MSG_ERROR([no, upgrade libc])
+-    fi
+-fi
+-
+ dnl =========================================
+ dnl Check for the Windows  SDK.
+ dnl =========================================
+@@ -12741,7 +12726,7 @@
+ 
+     case "$host_os" in
+ 
+-    aix*|dragonfly*|freebsd*|linux-gnu*|*netbsd*|openbsd*)
++    aix*|dragonfly*|freebsd*|linux-gnu*|linux-musl*|*netbsd*|openbsd*)
+         if test "$ENABLE_JAVA" != "" -a "$JDK"!="gcj"; then
+             pathmunge "$JAVA_HOME/bin" "after"
+         fi
+@@ -12789,7 +12774,6 @@
+     esac
+ 
+     pathmunge "$SRC_ROOT/solenv/bin" "before"
+-    pathmunge "." "before"
+ fi
+ 
+ AC_SUBST(LO_PATH)

diff --git 
a/app-office/libreoffice/files/libreoffice-4.4.1.2-musl-fix-execinfo.patch 
b/app-office/libreoffice/files/libreoffice-4.4.1.2-musl-fix-execinfo.patch
new file mode 100644
index 0000000..01fca6f
--- /dev/null
+++ b/app-office/libreoffice/files/libreoffice-4.4.1.2-musl-fix-execinfo.patch
@@ -0,0 +1,24 @@
+diff -ru sal.orig/osl/unx/backtrace.h sal/osl/unx/backtrace.h
+--- a/sal/osl/unx/backtrace.h  2015-01-22 22:05:28.000000000 -0200
++++ b/sal/osl/unx/backtrace.h  2015-02-02 17:06:27.765494731 -0200
+@@ -47,7 +47,7 @@
+ 
+ #endif /* defined SOLARIS || FREEBSD || NETBSD || OPENBSD */
+ 
+-#if defined (LINUX)
++#if defined (LINUX) && defined (__GLIBC__)
+ #include <execinfo.h>
+ #endif
+ 
+diff -ru sal.orig/osl/unx/signal.cxx sal/osl/unx/signal.cxx
+--- a/sal/osl/unx/signal.cxx   2015-01-22 22:05:28.000000000 -0200
++++ b/sal/osl/unx/signal.cxx   2015-02-02 17:06:53.495496086 -0200
+@@ -36,7 +36,7 @@
+ 
+ #endif /* MACOSX */
+ 
+-#ifdef LINUX
++#if defined (LINUX) && defined (__GLIBC__)
+ #include <execinfo.h>
+ #include <link.h>
+ #define INCLUDE_BACKTRACE

diff --git a/app-office/libreoffice/libreoffice-4.4.1.2-r99.ebuild 
b/app-office/libreoffice/libreoffice-4.4.1.2-r99.ebuild
new file mode 100644
index 0000000..cbf69a7
--- /dev/null
+++ b/app-office/libreoffice/libreoffice-4.4.1.2-r99.ebuild
@@ -0,0 +1,619 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: 
/var/cvsroot/gentoo-x86/app-office/libreoffice/libreoffice-4.4.1.2.ebuild,v 1.6 
2015/04/11 20:43:16 dilfridge Exp $
+
+EAPI=5
+
+KDE_REQUIRED="optional"
+QT_MINIMAL="4.7.4"
+KDE_SCM="git"
+CMAKE_REQUIRED="never"
+
+PYTHON_COMPAT=( python2_7 python3_3 python3_4 )
+PYTHON_REQ_USE="threads,xml"
+
+# experimental ; release ; old
+# Usually the tarballs are moved a lot so this should make
+# everyone happy.
+DEV_URI="
+       http://dev-builds.libreoffice.org/pre-releases/src
+       http://download.documentfoundation.org/libreoffice/src/${PV:0:5}/
+       http://download.documentfoundation.org/libreoffice/old/${PV}/
+"
+EXT_URI="http://ooo.itc.hu/oxygenoffice/download/libreoffice";
+ADDONS_URI="http://dev-www.libreoffice.org/src/";
+
+BRANDING="${PN}-branding-gentoo-0.8.tar.xz"
+# PATCHSET="${P}-patchset-01.tar.xz"
+
+[[ ${PV} == *9999* ]] && SCM_ECLASS="git-r3"
+inherit base multiprocessing autotools bash-completion-r1 check-reqs eutils 
java-pkg-opt-2 kde4-base pax-utils python-single-r1 multilib toolchain-funcs 
flag-o-matic versionator ${SCM_ECLASS}
+unset SCM_ECLASS
+
+DESCRIPTION="LibreOffice, a full office productivity suite"
+HOMEPAGE="http://www.libreoffice.org";
+SRC_URI="branding? ( http://dev.gentoo.org/~dilfridge/distfiles/${BRANDING} )"
+[[ -n ${PATCHSET} ]] && SRC_URI+=" 
http://dev.gentooexperimental.org/~scarabeus/${PATCHSET}";
+
+# Split modules following git/tarballs
+# Core MUST be first!
+# Help is used for the image generator
+MODULES="core help"
+# Only release has the tarballs
+if [[ ${PV} != *9999* ]]; then
+       for i in ${DEV_URI}; do
+               for mod in ${MODULES}; do
+                       if [[ ${mod} == core ]]; then
+                               SRC_URI+=" ${i}/${P}.tar.xz"
+                       else
+                               SRC_URI+=" ${i}/${PN}-${mod}-${PV}.tar.xz"
+                       fi
+               done
+               unset mod
+       done
+       unset i
+fi
+unset DEV_URI
+
+# Really required addons
+# These are bundles that can't be removed for now due to huge patchsets.
+# If you want them gone, patches are welcome.
+ADDONS_SRC+=" ${ADDONS_URI}/d62650a6f908e85643e557a236ea989c-vigra1.6.0.tar.gz"
+ADDONS_SRC+=" 
${ADDONS_URI}/1f24ab1d39f4a51faf22244c94a6203f-xmlsec1-1.2.14.tar.gz" # 
modifies source code
+ADDONS_SRC+=" collada? ( 
${ADDONS_URI}/4b87018f7fff1d054939d19920b751a0-collada2gltf-master-cb1d97788a.tar.bz2
 )"
+ADDONS_SRC+=" java? ( 
${ADDONS_URI}/17410483b5b5f267aa18b7e00b65e6e0-hsqldb_1_8_0.zip )"
+ADDONS_SRC+=" libreoffice_extensions_wiki-publisher? ( 
${ADDONS_URI}/a7983f859eafb2677d7ff386a023bc40-xsltml_2.1.2.zip )" # no release 
for 8 years, should we package it?
+ADDONS_SRC+=" libreoffice_extensions_scripting-javascript? ( 
${ADDONS_URI}/798b2ffdc8bcfe7bca2cf92b62caf685-rhino1_5R5.zip )" # Does not 
build with 1.6 rhino at all
+ADDONS_SRC+=" libreoffice_extensions_scripting-javascript? ( 
${ADDONS_URI}/35c94d2df8893241173de1d16b6034c0-swingExSrc.zip )" # requirement 
of rhino
+ADDONS_SRC+=" odk? ( 
http://download.go-oo.org/extern/185d60944ea767075d27247c3162b3bc-unowinreg.dll 
)" # not packageable
+SRC_URI+=" ${ADDONS_SRC}"
+
+unset ADDONS_URI
+unset EXT_URI
+unset ADDONS_SRC
+
+IUSE="bluetooth +branding coinmp collada +cups dbus debug eds firebird gltf 
gnome gstreamer
++gtk gtk3 jemalloc kde mysql odk postgres telepathy test vlc"
+
+LO_EXTS="nlpsolver scripting-beanshell scripting-javascript wiki-publisher"
+# Unpackaged separate extensions:
+# diagram: lo has 0.9.5 upstream is weirdly patched 0.9.4 -> wtf?
+# hunart: only on ooo extensions -> fubared download path somewhere on sf
+# numbertext, typo, validator, watch-window: ^^
+# oooblogger: no homepage or anything
+# Extensions that need extra work:
+for lo_xt in ${LO_EXTS}; do
+       IUSE+=" libreoffice_extensions_${lo_xt}"
+done
+unset lo_xt
+
+LICENSE="|| ( LGPL-3 MPL-1.1 )"
+SLOT="0"
+[[ ${PV} == *9999* ]] || \
+KEYWORDS="amd64 ~arm x86 ~amd64-linux ~x86-linux"
+
+COMMON_DEPEND="
+       ${PYTHON_DEPS}
+       app-arch/zip
+       app-arch/unzip
+       >=app-text/hunspell-1.3.2-r3
+       app-text/mythes
+       >=app-text/libabw-0.1.0
+       >=app-text/libexttextcat-3.2
+       >=app-text/libebook-0.1.1
+       >=app-text/libetonyek-0.1.1
+       app-text/liblangtag
+       >=app-text/libmspub-0.1.0
+       >=app-text/libmwaw-0.3.4
+       >=app-text/libodfgen-0.1.0
+       app-text/libwpd:0.10[tools]
+       app-text/libwpg:0.3
+       >=app-text/libwps-0.3.0
+       >=app-text/poppler-0.16:=[xpdf-headers(+),cxx]
+       >=dev-cpp/clucene-2.3.3.4-r2
+       =dev-cpp/libcmis-0.5*
+       dev-db/unixODBC
+       >=dev-libs/boost-1.55:=
+       dev-libs/expat
+       >=dev-libs/hyphen-2.7.1
+       >=dev-libs/icu-4.8.1.1:=
+       >=dev-libs/liborcus-0.7.0
+       >=dev-libs/librevenge-0.0.1
+       >=dev-libs/nspr-4.8.8
+       >=dev-libs/nss-3.12.9
+       >=dev-lang/perl-5.0
+       >=dev-libs/openssl-1.0.0d:0
+       >=dev-libs/redland-1.0.16
+       media-gfx/graphite2
+       >=media-libs/fontconfig-2.8.0
+       media-libs/freetype:2
+       >=media-libs/glew-1.10
+       >=media-libs/harfbuzz-0.9.18:=[icu(+)]
+       media-libs/lcms:2
+       >=media-libs/libpng-1.4:0=
+       >=media-libs/libcdr-0.1.0
+       >=media-libs/libfreehand-0.1.0
+       media-libs/libpagemaker
+       >=media-libs/libvisio-0.1.0
+       >=net-misc/curl-7.21.4
+       net-libs/neon
+       net-nds/openldap
+       sci-mathematics/lpsolve
+       virtual/jpeg:0
+       >=x11-libs/cairo-1.10.0[X]
+       x11-libs/libXinerama
+       x11-libs/libXrandr
+       x11-libs/libXrender
+       virtual/glu
+       virtual/opengl
+       bluetooth? ( net-wireless/bluez )
+       coinmp? ( sci-libs/coinor-mp )
+       collada? ( >=media-libs/opencollada-1.2.2_p20150207 )
+       cups? ( net-print/cups )
+       dbus? ( >=dev-libs/dbus-glib-0.92 )
+       eds? ( gnome-extra/evolution-data-server )
+       firebird? ( >=dev-db/firebird-2.5 )
+       gltf? ( media-libs/libgltf )
+       gnome? ( gnome-base/gconf:2 )
+       gtk? (
+               x11-libs/gdk-pixbuf[X]
+               >=x11-libs/gtk+-2.24:2
+       )
+       gtk3? ( >=x11-libs/gtk+-3.2:3 )
+       gstreamer? (
+               media-libs/gstreamer:1.0
+               media-libs/gst-plugins-base:1.0
+       )
+       jemalloc? ( dev-libs/jemalloc )
+       libreoffice_extensions_scripting-beanshell? ( >=dev-java/bsh-2.0_beta4 )
+       libreoffice_extensions_scripting-javascript? ( dev-java/rhino:1.6 )
+       libreoffice_extensions_wiki-publisher? (
+               dev-java/commons-codec:0
+               dev-java/commons-httpclient:3
+               dev-java/commons-lang:2.1
+               dev-java/commons-logging:0
+               dev-java/tomcat-servlet-api:3.0
+       )
+       mysql? ( >=dev-db/mysql-connector-c++-1.1.0 )
+       postgres? ( >=dev-db/postgresql-9.0[kerberos] )
+       telepathy? (
+               dev-libs/glib:2
+               >=net-libs/telepathy-glib-0.18.0
+               >=x11-libs/gtk+-2.24:2
+       )
+"
+
+RDEPEND="${COMMON_DEPEND}
+       !app-office/libreoffice-bin
+       !app-office/libreoffice-bin-debug
+       !<app-office/openoffice-bin-3.4.0-r1
+       !app-office/openoffice
+       media-fonts/libertine
+       media-fonts/liberation-fonts
+       media-fonts/urw-fonts
+       java? ( >=virtual/jre-1.6 )
+       kde? ( || ( $(add_kdeapps_dep kioclient) $(add_kdebase_dep kioclient) ) 
)
+       vlc? ( media-video/vlc )
+"
+
+if [[ ${PV} != *9999* ]]; then
+       PDEPEND="=app-office/libreoffice-l10n-$(get_version_component_range 
1-2)*"
+else
+       # Translations are not reliable on live ebuilds
+       # rather force people to use english only.
+       PDEPEND="!app-office/libreoffice-l10n"
+fi
+
+# FIXME: cppunit should be moved to test conditional
+#        after everything upstream is under gbuild
+#        as dmake execute tests right away
+DEPEND="${COMMON_DEPEND}
+       >=dev-libs/libatomic_ops-7.2d
+       >=dev-libs/libxml2-2.7.8
+       dev-libs/libxslt
+       dev-perl/Archive-Zip
+       dev-util/cppunit
+       >=dev-util/gperf-3
+       dev-util/intltool
+       >=dev-util/mdds-0.10.3:=
+       media-libs/glm
+       net-misc/npapi-sdk
+       >=sys-apps/findutils-4.4.2
+       sys-devel/bison
+       sys-apps/coreutils
+       sys-devel/flex
+       sys-devel/gettext
+       >=sys-devel/make-3.82
+       sys-devel/ucpp
+       sys-libs/zlib
+       virtual/pkgconfig
+       x11-libs/libXt
+       x11-libs/libXtst
+       x11-proto/randrproto
+       x11-proto/xextproto
+       x11-proto/xineramaproto
+       x11-proto/xproto
+       java? (
+               >=virtual/jdk-1.6
+               >=dev-java/ant-core-1.7
+       )
+       odk? ( >=app-doc/doxygen-1.8.4 )
+       test? ( dev-util/cppunit )
+"
+
+PATCHES=(
+       # not upstreamable stuff
+       "${FILESDIR}/${PN}-4.4-system-pyuno.patch"
+
+       # from 4.4 branch
+       "${FILESDIR}/${PN}-4.4.0.3-gcc-4.9-Os-link-failure.patch" # bug 538348
+
+       # from master branch
+       "${FILESDIR}/${PN}-4.4.0.3-telepathy-build-fix.patch"
+       "${FILESDIR}/${PN}-4.4.1.2-add-kde4-open-url-script.patch"
+       "${FILESDIR}/${PN}-4.4.1.2-improve-KDE4FilePicker.patch"
+       "${FILESDIR}/${PN}-4.3.5.2-remove-bashisms.patch" # bug 525454
+       "${FILESDIR}/${PN}-4.4.1.2-musl-fix-execinfo.patch"
+       "${FILESDIR}/${PN}-4.4.1.2-fix-includes.patch"
+       "${FILESDIR}/${PN}-4.4.1.2-linux-musl.patch"
+)
+
+REQUIRED_USE="
+       ${PYTHON_REQUIRED_USE}
+       bluetooth? ( dbus )
+       collada? ( gltf )
+       gnome? ( gtk )
+       eds? ( gnome )
+       telepathy? ( gtk )
+       libreoffice_extensions_nlpsolver? ( java )
+       libreoffice_extensions_scripting-beanshell? ( java )
+       libreoffice_extensions_scripting-javascript? ( java )
+       libreoffice_extensions_wiki-publisher? ( java )
+"
+
+CHECKREQS_MEMORY="512M"
+CHECKREQS_DISK_BUILD="6G"
+
+pkg_pretend() {
+       local pgslot
+
+       if [[ ${MERGE_TYPE} != binary ]]; then
+               check-reqs_pkg_pretend
+
+               if [[ $(gcc-major-version) -lt 4 ]] || \
+                                ( [[ $(gcc-major-version) -eq 4 && 
$(gcc-minor-version) -lt 6 ]] ) \
+                               ; then
+                       eerror "Compilation with gcc older than 4.6 is not 
supported"
+                       die "Too old gcc found."
+               fi
+       fi
+
+       # Ensure pg version but we have to be sure the pg is installed (first
+       # install on clean system)
+       if use postgres && has_version dev-db/postgresql; then
+                pgslot=$(postgresql-config show)
+                if [[ ${pgslot//.} < 90 ]] ; then
+                       eerror "PostgreSQL slot must be set to 9.0 or higher."
+                       eerror "    postgresql-config set 9.0"
+                       die "PostgreSQL slot is not set to 9.0 or higher."
+                fi
+       fi
+}
+
+pkg_setup() {
+       java-pkg-opt-2_pkg_setup
+       kde4-base_pkg_setup
+       python-single-r1_pkg_setup
+
+       [[ ${MERGE_TYPE} != binary ]] && check-reqs_pkg_setup
+}
+
+src_unpack() {
+       local mod mod2 dest tmplfile tmplname mypv
+
+       [[ -n ${PATCHSET} ]] && unpack ${PATCHSET}
+       use branding && unpack "${BRANDING}"
+
+       if [[ ${PV} != *9999* ]]; then
+               unpack "${P}.tar.xz"
+               for mod in ${MODULES}; do
+                       [[ ${mod} == core ]] && continue
+                       unpack "${PN}-${mod}-${PV}.tar.xz"
+               done
+       else
+               for mod in ${MODULES}; do
+                       mypv=${PV/.9999}
+                       [[ ${mypv} != ${PV} ]] && 
EGIT_BRANCH="${PN}-${mypv/./-}"
+                       EGIT_CHECKOUT_DIR="${WORKDIR}/${P}"
+                       [[ ${mod} != core ]] && 
EGIT_CHECKOUT_DIR="${WORKDIR}/${PN}-${mod}-${PV}"
+                       
EGIT_REPO_URI="git://anongit.freedesktop.org/${PN}/${mod}"
+                       git-r3_src_unpack
+                       if [[ ${mod} != core ]]; then
+                               mod2=${mod}
+                               # mapping does not match on help
+                               [[ ${mod} == help ]] && mod2="helpcontent2"
+                               mkdir -p "${S}/${mod2}/" || die
+                               mv -n "${WORKDIR}/${PN}-${mod}-${PV}"/* 
"${S}/${mod2}" || die
+                               rm -rf "${WORKDIR}/${PN}-${mod}-${PV}"
+                       fi
+               done
+               unset EGIT_CHECKOUT_DIR EGIT_REPO_URI EGIT_BRANCH
+       fi
+}
+
+src_prepare() {
+       # optimization flags
+       export GMAKE_OPTIONS="${MAKEOPTS}"
+       # System python 2.7 enablement:
+       export PYTHON_CFLAGS=$(python_get_CFLAGS)
+       export PYTHON_LIBS=$(python_get_LIBS)
+
+       if use collada; then
+               export 
OPENCOLLADA_CFLAGS="-I/usr/include/opencollada/COLLADABaseUtils 
-I/usr/include/opencollada/COLLADAFramework 
-I/usr/include/opencollada/COLLADASaxFrameworkLoader 
-I/usr/include/opencollada/GeneratedSaxParser"
+               export OPENCOLLADA_LIBS="-L /usr/$(get_libdir)/opencollada 
-lOpenCOLLADABaseUtils -lOpenCOLLADAFramework -lOpenCOLLADASaxFrameworkLoader 
-lGeneratedSaxParser"
+       fi
+
+       # patchset
+       if [[ -n ${PATCHSET} ]]; then
+               EPATCH_FORCE="yes" \
+               EPATCH_SOURCE="${WORKDIR}/${PATCHSET/.tar.xz/}" \
+               EPATCH_SUFFIX="patch" \
+               epatch
+       fi
+
+       base_src_prepare
+
+       AT_M4DIR="m4" eautoreconf
+       # hack in the autogen.sh
+       touch autogen.lastrun
+
+       # system pyuno mess
+       sed \
+               -e "s:%eprefix%:${EPREFIX}:g" \
+               -e "s:%libdir%:$(get_libdir):g" \
+               -i pyuno/source/module/uno.py \
+               -i pyuno/source/officehelper.py || die
+       # sed in the tests
+       sed -i \
+               -e 's#all : build unitcheck#all : build#g' \
+               solenv/gbuild/Module.mk || die
+       sed -i \
+               -e 's#check: dev-install subsequentcheck#check: unitcheck 
slowcheck dev-install subsequentcheck#g' \
+               -e 's#Makefile.gbuild all slowcheck#Makefile.gbuild all#g' \
+               Makefile.in || die
+
+       if use branding; then
+               # hack...
+               mv -v "${WORKDIR}/branding-intro.png" 
"${S}/icon-themes/galaxy/brand/intro.png" || die
+       fi
+}
+
+src_configure() {
+       local java_opts
+       local internal_libs
+       local lo_ext
+       local ext_opts
+
+       # sane: just sane.h header that is used for scan in writer, not
+       #       linked or anything else, worthless to depend on
+       # vigra: just uses templates from there
+       #        it is serious pain in the ass for packaging
+       #        should be replaced by boost::gil if someone interested
+       internal_libs+="
+               --without-system-sane
+               --without-system-vigra
+       "
+
+       # libreoffice extensions handling
+       for lo_xt in ${LO_EXTS}; do
+               if [[ "${lo_xt}" == "scripting-beanshell" || "${lo_xt}" == 
"scripting-javascript" ]]; then
+                       ext_opts+=" $(use_enable 
libreoffice_extensions_${lo_xt} ${lo_xt})"
+               else
+                       ext_opts+=" $(use_enable 
libreoffice_extensions_${lo_xt} ext-${lo_xt})"
+               fi
+       done
+
+       if use java; then
+               # hsqldb: system one is too new
+               java_opts="
+                       --without-junit
+                       --without-system-hsqldb
+                       --with-ant-home="${ANT_HOME}"
+                       --with-jdk-home=$(java-config --jdk-home 2>/dev/null)
+                       --with-jvm-path="${EPREFIX}/usr/lib/"
+               "
+
+               use libreoffice_extensions_scripting-beanshell && \
+                       java_opts+=" --with-beanshell-jar=$(java-pkg_getjar bsh 
bsh.jar)"
+
+               use libreoffice_extensions_scripting-javascript && \
+                       java_opts+=" --with-rhino-jar=$(java-pkg_getjar 
rhino-1.6 js.jar)"
+
+               if use libreoffice_extensions_wiki-publisher; then
+                       java_opts+="
+                               --with-commons-codec-jar=$(java-pkg_getjar 
commons-codec commons-codec.jar)
+                               --with-commons-httpclient-jar=$(java-pkg_getjar 
commons-httpclient-3 commons-httpclient.jar)
+                               --with-commons-lang-jar=$(java-pkg_getjar 
commons-lang-2.1 commons-lang.jar)
+                               --with-commons-logging-jar=$(java-pkg_getjar 
commons-logging commons-logging.jar)
+                               --with-servlet-api-jar=$(java-pkg_getjar 
tomcat-servlet-api-3.0 servlet-api.jar)
+                       "
+               fi
+       fi
+
+       # system headers/libs/...: enforce using system packages
+       # --enable-cairo: ensure that cairo is always required
+       # --enable-graphite: disabling causes build breakages
+       # --enable-*-link: link to the library rather than just dlopen on 
runtime
+       # --enable-release-build: build the libreoffice as release
+       # --disable-fetch-external: prevent dowloading during compile phase
+       # --disable-gnome-vfs: old gnome virtual fs support
+       # --disable-kdeab: kde3 adressbook
+       # --disable-kde: kde3 support
+       # --disable-systray: quickstarter does not actually work at all so do 
not
+       #   promote it
+       # --enable-extension-integration: enable any extension integration 
support
+       # --without-{fonts,myspell-dicts,ppsd}: prevent install of sys pkgs
+       # --disable-report-builder: too much java packages pulled in without 
pkgs
+       econf \
+               --docdir="${EPREFIX}/usr/share/doc/${PF}/" \
+               --with-system-headers \
+               --with-system-libs \
+               --with-system-jars \
+               --with-system-dicts \
+               --enable-cairo-canvas \
+               --enable-graphite \
+               --enable-largefile \
+               --enable-mergelibs \
+               --enable-neon \
+               --enable-python=system \
+               --enable-randr \
+               --enable-randr-link \
+               --enable-release-build \
+               --disable-hardlink-deliver \
+               --disable-ccache \
+               --disable-crashdump \
+               --disable-dependency-tracking \
+               --disable-epm \
+               --disable-fetch-external \
+               --disable-gnome-vfs \
+               --disable-gstreamer-0-10 \
+               --disable-report-builder \
+               --disable-kdeab \
+               --disable-kde \
+               --disable-online-update \
+               --disable-systray \
+               --with-alloc=$(use jemalloc && echo "jemalloc" || echo 
"system") \
+               --with-build-version="Gentoo official package" \
+               --enable-extension-integration \
+               --with-external-dict-dir="${EPREFIX}/usr/share/myspell" \
+               --with-external-hyph-dir="${EPREFIX}/usr/share/myspell" \
+               --with-external-thes-dir="${EPREFIX}/usr/share/myspell" \
+               --with-external-tar="${DISTDIR}" \
+               --with-lang="" \
+               --with-parallelism=$(makeopts_jobs) \
+               --with-system-ucpp \
+               --with-vendor="Gentoo Foundation" \
+               --with-x \
+               --without-fonts \
+               --without-myspell-dicts \
+               --without-help \
+               --with-helppack-integration \
+               --without-sun-templates \
+               $(use_enable bluetooth sdremote-bluetooth) \
+               $(use_enable coinmp) \
+               $(use_enable collada) \
+               $(use_enable cups) \
+               $(use_enable debug) \
+               $(use_enable dbus) \
+               $(use_enable eds evolution2) \
+               $(use_enable firebird firebird-sdbc) \
+               $(use_enable gltf) \
+               $(use_enable gnome gconf) \
+               $(use_enable gnome gio) \
+               $(use_enable gnome lockdown) \
+               $(use_enable gstreamer gstreamer-1-0) \
+               $(use_enable gtk) \
+               $(use_enable gtk3) \
+               $(use_enable kde kde4) \
+               $(use_enable mysql ext-mariadb-connector) \
+               $(use_enable odk) \
+               $(use_enable postgres postgresql-sdbc) \
+               $(use_enable telepathy) \
+               $(use_enable vlc) \
+               $(use_with coinmp system-coinmp) \
+               $(use_with collada system-opencollada) \
+               $(use_with gltf system-libgltf) \
+               $(use_with java) \
+               $(use_with mysql system-mysql-cppconn) \
+               $(use_with odk doxygen) \
+               ${internal_libs} \
+               ${java_opts} \
+               ${ext_opts}
+}
+
+src_compile() {
+       # more and more LO stuff tries to use OpenGL, including tests during 
build
+       # bug 501508, bug 540624, bug 545974 and probably more
+       addpredict /dev/dri
+       addpredict /dev/ati
+       addpredict /dev/nvidiactl
+
+       # hack for offlinehelp, this needs fixing upstream at some point
+       # it is broken because we send --without-help
+       # https://bugs.freedesktop.org/show_bug.cgi?id=46506
+       (
+               grep "^export" "${S}/config_host.mk" > "${T}/config_host.mk"
+               source "${T}/config_host.mk" 2&> /dev/null
+
+               local path="${WORKDIR}/helpcontent2/source/auxiliary/"
+               mkdir -p "${path}" || die
+
+               echo "perl \"${S}/helpcontent2/helpers/create_ilst.pl\" 
-dir=icon-themes/galaxy/res/helpimg > \"${path}/helpimg.ilst\""
+               perl "${S}/helpcontent2/helpers/create_ilst.pl" \
+                       -dir=icon-themes/galaxy/res/helpimg \
+                       > "${path}/helpimg.ilst"
+               [[ -s "${path}/helpimg.ilst" ]] || ewarn "The help images list 
is empty, something is fishy, report a bug."
+       )
+
+       local target
+       use test && target="build" || target="build-nocheck"
+
+       # this is not a proper make script
+       make ${target} || die
+}
+
+src_test() {
+       make unitcheck || die
+       make slowcheck || die
+}
+
+src_install() {
+       # This is not Makefile so no buildserver
+       make DESTDIR="${D}" distro-pack-install -o build -o check || die
+
+       # Fix bash completion placement
+       newbashcomp "${ED}"/etc/bash_completion.d/libreoffice.sh ${PN}
+       bashcomp_alias \
+               libreoffice \
+               unopkg loimpress lobase localc lodraw lomath lowriter 
lofromtemplate loweb loffice
+       rm -rf "${ED}"/etc/ || die
+
+       if use branding; then
+               insinto /usr/$(get_libdir)/${PN}/program
+               newins "${WORKDIR}/branding-sofficerc" sofficerc
+               dodir /etc/env.d
+               echo 
"CONFIG_PROTECT=/usr/$(get_libdir)/${PN}/program/sofficerc" > 
"${ED}"/etc/env.d/99${PN}
+       fi
+
+       # Hack for offlinehelp, this needs fixing upstream at some point.
+       # It is broken because we send --without-help
+       # https://bugs.freedesktop.org/show_bug.cgi?id=46506
+       insinto /usr/$(get_libdir)/libreoffice/help
+       doins xmlhelp/util/*.xsl
+
+       # Remove desktop files for support to old installs that can't parse mime
+       rm -rf "${ED}"/usr/share/mimelnk/
+
+       # FIXME: Hack add missing file
+       insinto /usr/$(get_libdir)/${PN}/program
+       doins "${S}"/instdir/program/libsaxlo.so
+
+       pax-mark -m "${ED}"/usr/$(get_libdir)/libreoffice/program/soffice.bin
+       pax-mark -m "${ED}"/usr/$(get_libdir)/libreoffice/program/unopkg.bin
+}
+
+pkg_preinst() {
+       # Cache updates - all handled by kde eclass for all environments
+       kde4-base_pkg_preinst
+}
+
+pkg_postinst() {
+       kde4-base_pkg_postinst
+
+       use java || \
+               ewarn 'If you plan to use lbase application you should enable 
java or you will get various crashes.'
+}
+
+pkg_postrm() {
+       kde4-base_pkg_postrm
+}

diff --git a/app-office/libreoffice/metadata.xml 
b/app-office/libreoffice/metadata.xml
new file mode 100644
index 0000000..757568b
--- /dev/null
+++ b/app-office/libreoffice/metadata.xml
@@ -0,0 +1,20 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd";>
+<pkgmetadata>
+  <herd>openoffice</herd>
+  <longdescription>LibreOffice is a fork of OpenOffice.org. 
+This ebuild allows you to compile it yourself. Unfortunately this 
+compilation can take up to a day depending on the speed of your 
+computer. It will however make a snappier openoffice than the binary 
+version</longdescription>
+  <use>
+    <flag name="coinmp">Use sci-libs/coinor-mp as alternative solver</flag>
+    <flag name="collada">Enable Collada for rendering 3D models stored in 
*.dae and *.kmz format</flag>
+    <flag name="gltf">Use media-libs/libgltf for inserting 3D models in the 
glTF format into presentations</flag>
+    <flag name="gtk3">Enable highly experimental gtk3 frontend</flag>
+    <flag name="jemalloc">Use <pkg>dev-libs/jemalloc</pkg> for 
allocations</flag>
+    <flag name="odk">Build the Office Development Kit</flag>
+    <flag name="telepathy">Enable document colaboration features using 
telepathy communication framework.</flag>
+    <flag name="vlc">Use <pkg>media-video/vlc</pkg> for video embedding</flag>
+  </use>
+</pkgmetadata>

Reply via email to